<?php

/*
Autor: Ondrej Jurecek (ondrej@jurecek.net)
Datum posledni zmeny: 05.04.2003
*/

//dl('php_gd.dll');

class skin_counter {

    var $PATH;                         // cesta ke zdrojovmu souboru
    var $IMAGE;                        // handler natenho obrzku
    var $IMAGE_PARTS       = array();  // jednotliv sti obrzk
    var $POSITION_DATA     = array();  // souadnice jednotlivch obrzk.. ['MAIN'['x', 'y', 'w', 'h']-zklad(=podklad), '0'['x', 'y', 'w', 'h'], '1', '2', .., '9'-sla obrzk]
    var $TYPE;                         // slo typu vstupnho obrzku nap. 2=JPEG, 3=PNG
    var $ERROR;                        // slo chyby


    function set_path($path) {
      if (!empty($path)):
        $this->PATH = $path;
      endif;
    }

    function set_type($type) {
      if (!empty($type)):
        $this->TYPE = $type;
      else:
        $this->TYPE = $this->info ($this->PATH, 1);
      endif;
    }

    function set_type_default($indi = NULL) {
      if (empty($this->TYPE) OR !empty($indi)):
        $this->TYPE = 2;
      endif;
    }

    function set_position($key, $data) { //data je typu array!
      if (is_array($data) AND in_array('X', array_keys ($data))
                          AND in_array('Y', array_keys ($data))
                          AND in_array('W', array_keys ($data))
                          AND in_array('H', array_keys ($data))):
        $this->POSITION_DATA[$key] = $data;
      endif;
    }

    function set_position_one($key, $x, $y, $w, $h) {
      $this->POSITION_DATA[$key] = array('X'=>$x, 'Y'=>$y, 'W'=>$w, 'H'=>$h);
    }

    function clear_position() {
      $this->POSITION_DATA = array();
    }

    function set_distance($distance) {
      $this->POSITION_DATA['DISTANCE'] = $distance;
    }

    function set_startpoint($x, $y) {
      $this->POSITION_DATA['STARTPOINT'] = array('X'=>$x, 'Y'=>$y);
    }

    function set_startpoint_by_rightside($x) {
      if (isset($this->POSITION_DATA['MAIN'])):
        $this->POSITION_DATA['STARTPOINT']['X'] = $this->POSITION_DATA['MAIN']['W'] - $x;
      endif;
    }

    function set_startpoint_by_topside($y) {
      settype($this->POSITION_DATA['STARTPOINT'], "array");
      $this->POSITION_DATA['STARTPOINT']['Y'] = $y;
    }

    function set_startpoint_default($indi = NULL) {
      if (!isset($this->POSITION_DATA['STARTPOINT']) OR !empty($indi)):
        reset($this->POSITION_DATA);
        while (list($key, $val) = each ($this->POSITION_DATA)) {
          if ($key=='MAIN'): continue; endif;
          if (is_array($val) AND isset($val['X']) AND isset($val['Y']) AND isset($val['W']) AND isset($val['H'])):
            $found = 1;
            break;
          endif;
        }
        if ($found):
          $x = floor($this->POSITION_DATA['MAIN']['W'] - ($val['W'] + $val['W'] / 12));
          $y = floor(($this->POSITION_DATA['MAIN']['H'] - $val['H']) / 2);
          $this->set_startpoint ($x, $y);
        endif;
      endif;
    }

    function set_distance_default($indi = NULL) {
      if (!isset($this->POSITION_DATA['DISTANCE']) OR !empty($indi)):
        reset($this->POSITION_DATA);
        while (list($key, $val) = each ($this->POSITION_DATA)) {
          if ((string)$key=='MAIN'): continue; endif;
          if (is_array($val) AND isset($val['X']) AND isset($val['Y']) AND isset($val['W']) AND isset($val['H'])):
            $found = 1;
            break;
          endif;
        }
        if ($found):
          $this->set_distance(floor($val['W'] / 4));
        endif;
      endif;
    }

    function clear_distance() {
      unset($this->POSITION_DATA['DISTANCE']);
    }

    function skin_counter($path = NULL, $position_data = NULL, $type = NULL) {
      $this->set_path($path);
      $this->set_type($type);

      if (is_array($position_data)):
        while (list ($key, $val) = each ($position_data)) {
          if (is_array($val)):
            $this->set_position($key, $val);
          endif;
        }
      endif;
    }

    function output($number, $type = NULL) {
      $this->set_type($type);

      $this->IMAGE = $this->load();

      settype($number, "string");
      if (ereg ("([^0-9]+)", $number)):
//echo "chybn slo ;-(";
        $number = '0';
      endif;
      $number_comp = array();
      $max = strlen($number);
      for ($i=0; $i < $max; $i++):
        $number_arr[$i] = $number[$i];
      endfor;

      $this->parse_image($number_arr, array('MAIN'));
      $this->set_distance_default();
      $this->set_startpoint_default();

      $this->make_counter($number_arr, $result);

      switch ($this->TYPE):
      default:
      case 2: imagejpeg ($result, '', 70);
              break;
      case 3: imagepng  ($result);
              break;
      case 6: imagewbmp ($result);
              break;
      endswitch;
    }

    function parse_image($use_only = NULL, $use_always = NULL) {
      if (is_array($this->POSITION_DATA) AND !empty($this->IMAGE)):
        reset($this->POSITION_DATA);
        while (list ($key, $val) = each ($this->POSITION_DATA)) {
          if ((is_array($use_only) AND !in_array((string)$key, $use_only, TRUE)) and
              !(is_array($use_always) AND in_array($key, $use_always, TRUE))):
            continue;
          endif;
          if (is_array($val) AND isset($val['X']) AND isset($val['Y']) AND isset($val['W']) AND isset($val['H'])):
            $this->IMAGE_PARTS[$key] = imagecreate ($val['W'], $val['H']);
            if (!imagecopy($this->IMAGE_PARTS[$key], $this->IMAGE, 0, 0, $val['X'], $val['Y'], $val['W'], $val['H'])):
              unset($this->IMAGE_PARTS[$key]);
            endif;
          endif;
        }
      endif;
    }

    function make_counter(&$number_arr, &$output) {
      $number_arr = array_reverse ($number_arr);
//      print_r($this->IMAGE_PARTS);
      $output = imagecreate($this->POSITION_DATA['MAIN']['W'], $this->POSITION_DATA['MAIN']['H']);
      imagecopy($output, $this->IMAGE_PARTS['MAIN'], 0, 0, 0, 0, $this->POSITION_DATA['MAIN']['W'], $this->POSITION_DATA['MAIN']['H']);
      $indi_n = 0;
      $pos_x = $this->POSITION_DATA['STARTPOINT']['X'];
      $pos_y = $this->POSITION_DATA['STARTPOINT']['Y'];
      while (list(, $val) = each($number_arr)) {
        if ($indi_n):
          $pos_x -= $this->POSITION_DATA['DISTANCE'];
          $pos_x -= $this->POSITION_DATA[$val]['W'];
        else:
          $indi_n = 1;
        endif;
        if ($pos_x < 0):
          break;
        endif;
// echo "POS_X: $pos_x; POS_Y: $pos_y<br>";
        imagecopy($output, $this->IMAGE_PARTS[$val], $pos_x, $pos_y, 0, 0, $this->POSITION_DATA[$val]['W'], $this->POSITION_DATA[$val]['H']);
      }
    }

    function init() {
      unset ($this->PATH);
      unset ($this->IMAGE);
      unset ($this->IMAGE_PARTS);
      unset ($this->POSITION_DATA);
      unset ($this->TYPE);
      unset ($this->ERROR);
    }

    function error_clear() {
      unset ($this->ERROR);
    }

    function error_no() {
      return $this->ERROR;
    }

    function error_text() {
      switch ($this->ERROR):
      case 1: return 'obrzek nenalezen';
              break;
      case 2: return 'obrzek nebyl naten';
              break;
      endswitch;
    }

    function load() {
      switch ($this->info ($this->PATH, 1)):
      case 2: $cmd = 'imagecreatefromjpeg';
              break;
      case 3: $cmd = 'imagecreatefrompng';
              break;
      case 6: $cmd = 'imagecreatefromwbmp';
              break;
      endswitch;
      if (function_exists($cmd)):
        $im_load = $cmd($this->PATH);
      endif;
      if (!$im_load): /* See if it failed */
        $this->ERROR = 2;
      endif;
      return $im_load;
    }

    function imagetype2string( $number, &$text ) {
      switch ($number):
        case 1: $res = "GIF"; break;
        case 2: $res = "JPG"; break;
        case 3: $res = "PNG"; break;
        case 4: $res = "SWF"; break;
        case 5: $res = "PSD"; break;
        case 6: $res = "BMP"; break;
        case 7:
        case 8: $res = "TIFF"; break;
        case 9: $res = "JPC";  break;
        case 10: $res = "JP2"; break;
        case 11: $res = "JPX"; break;
        case 12: $res = "JB2"; break;
        case 13: $res = "SWC"; break;
        case 14: $res = "IFF"; break;
        default: $res = "";
      endswitch;
      $text = $res;
    }

    function info($path, $spec) {
      $res = 0;
      if (!empty($path) AND file_exists ($path)):
      switch ($spec):
        case 1: $info = getimagesize ($path);  //formt (integer)
                $res = $info[2];
                break;
        case 2: $info = getimagesize ($path);  //formt (string)
                $this->imagetype2string($info[2], $res);
                $res = "typ: " . $res;
                break;
        endswitch;
      else:
        $this->ERROR = 1;
      endif;
      return $res;
    }

} // end of class skin_counter

?>